using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace IndiaStudyChannel.Colleges
{
	/// <summary>
	/// Summary description for AddCollege.
	/// </summary>
	public partial class AddCollege : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.DropDownList ddlCourseTypes;
	
		protected void Page_Load(object sender, System.EventArgs e)
		{
            this.Page.Form.DefaultFocus = txtCollegeName.ClientID;

			if ( Page.IsPostBack )
				return;

			// Make sure user has logged in before can post a university.

			if ( Session["CurrentUser"] == null )
			{
				// User has not logged in. Redirect to login page and pass current URL as a query string
				// so that after login, we can redirect user back to this page again.
				Response.Redirect("~/Members/Login.aspx?ReturnUrl=" + Request.Url.PathAndQuery);
			}

			// Load the list of universities in the drop down.
			LoadUniversities();

			string collegeId = Request.QueryString["CollegeId"];
			if ( collegeId == null )
			{
				// No college id is passed in query string. So we are here to add a new college.
			}
			else
			{
				// College Id is passed as query string. Let us edit the existing college data.
				LoadCollegeDetails( int.Parse(collegeId) );
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    

		}
		#endregion

		protected void btnSubmit_Click(object sender, System.EventArgs e)
		{
			if ( txtDescription.Text.Length > 1024 )
			{
				lblMessage.Text = "Description too long. Maximum length is 1024 characters.";
				return;
			}

			if ( txtAddress.Text.Length > 256 )
			{
				lblMessage.Text = "Address too long. Maximum length is 256 characters.";
				return;
			}

			// Must replace all single quotes with 2 single quotes to avoid failing the query since
			// single quote is an escape character in the database.

			string collegename = txtCollegeName.Text.Replace("'","''");
			string address = txtAddress.Text.Replace("'","''");
			string city = txtCity.Text.Replace("'","''");
			string state = txtState.Text.Replace("'","''");
			string phone1 = txtPhoneNumber1.Text.Replace("'","''");
			string phone2 = txtPhoneNumber2.Text.Replace("'","''");
			string email = txtEmail.Text.Replace("'","''");
			string homepage = txtHomePage.Text.Replace("'","''");
			string description = txtDescription.Text.Replace("'","''");
			int universityId = Int32.Parse(ddlUniversities.SelectedItem.Value.ToString());
			string posteduser = Session["Currentuser"].ToString();

            int artsAndScienceCollege = chkArtsScience.Checked == true ? 1 : 0;
            int lawCollege = chkLaw.Checked == true ? 1 : 0;
            int distanceEducationCenter = chkDistanceEducation.Checked == true ? 1 : 0;
            int universityCollege = chkUniversityCenter.Checked == true ? 1 : 0;
            int polytechnic = chkPolytechnic.Checked == true ? 1 : 0;
            int bedCollege = chkBed.Checked == true ? 1 : 0;
            int nursingCollege = chkNursing.Checked == true ? 1 : 0;
            int engineeringCollege = chkEngineering.Checked == true ? 1 : 0;
            int medicalCollege = chkMedical.Checked == true ? 1 : 0;
            
			string collegeId = Request.QueryString["CollegeId"];
			if ( collegeId == null )
			{
				// There is no query string passed. We are adding a college.
                string query = "insert into Colleges (CollegeName, Address, City, State, PhoneNumber1, PhoneNumber2, Email, HomePage, UniversityId, Description, PostedUser, ArtsAndScienceCollege, LawCollege, DistanceEducationCenter, UniversityCollege, Polytechnic, BedCollege, NursingCollege, EngineeringCollege, MedicalCollege) values('" + collegename + "','" + address + "', '" + city + "', '" + state + "', '" + phone1 + "','" + phone2 + "','" + email + "','" + homepage + "', " + universityId.ToString() + ", '" + description + "', '" + posteduser + "', " + artsAndScienceCollege + ", " + lawCollege + ", " + distanceEducationCenter + ", " + universityCollege + ", " + polytechnic + ", " + bedCollege + ", " + nursingCollege + ", " + engineeringCollege + ", " + medicalCollege + " )";

				Utils.DataManager.ExecuteNonQuery(query);
			}
			else
			{
				// collegeId is passed as query string... this means we are editing an existing college.
                string query = "Update Colleges set CollegeName= '" + collegename + "', Address = '" + address + "', City = '" + city + "', State = '" + state + "', PhoneNumber1 = '" + phone1 + "', PhoneNumber2 = '" + phone2 + "', Email = '" + email + "', HomePage = '" + homepage + "', UniversityId = " + universityId.ToString() + ", Description = '" + description + "', ArtsAndScienceCollege = " + artsAndScienceCollege + ", LawCollege = " + lawCollege + ", DistanceEducationCenter = " + distanceEducationCenter + ", UniversityCollege = " + universityCollege + ", Polytechnic = " + polytechnic + ", BedCollege = " + bedCollege + ", NursingCollege = " + nursingCollege + ", EngineeringCollege = " + engineeringCollege + ", MedicalCollege = " + medicalCollege   + " where Id = " + int.Parse(collegeId);

				Utils.DataManager.ExecuteNonQuery(query);

				Response.Redirect ("CollegeDetails.aspx?CollegeId=" + int.Parse(collegeId));
			}
			

			Response.Redirect("Index.aspx");
		}

		/// <summary>
		/// This method pre populates the existing data of the current college.
		/// </summary>
		/// <param name="collegeId"></param>
		private void LoadCollegeDetails( int collegeId )
		{
            string query = "Select Id, CollegeName, City, State, Address, PhoneNumber1, PhoneNumber2, Email, HomePage, UniversityId, Description, PostedUser, ArtsAndScienceCollege, LawCollege, DistanceEducationCenter, UniversityCollege, Polytechnic, BedCollege, NursingCollege, EngineeringCollege, MedicalCollege from Colleges where Id = " + collegeId;
			DataTable table = Utils.DataManager.ExecuteQuery(query);
			
			if ( table.Rows.Count > 0 )
			{
				DataRow dr = table.Rows[0];

				// Only the administrator or the person who originally submitted this course can edit this. Make sure 
				// nobody else is trying to edit this.
				if ( !Utils.Utils.IsOwner(dr["PostedUser"]) )
				{
					lblMessage.Text = "Sorry, you are not the owner of this submission and you are not allowed to edit this. Please <a href='../Members/Login.aspx?ReturnUrl=" + Request.Url.PathAndQuery + "'>Sign In</a> using an Id with appropriate permissions.";
					btnSubmit.Enabled = false;
					return;
				}

				txtCollegeName.Text = dr["CollegeName"].ToString();
				txtAddress.Text = dr["Address"].ToString();
				txtCity.Text = dr["City"].ToString();
				txtState.Text = dr["State"].ToString();
				txtPhoneNumber1.Text = dr["PhoneNumber1"].ToString();
				txtPhoneNumber2.Text = dr["PhoneNumber2"].ToString();
				txtEmail.Text = dr["Email"].ToString();
				txtHomePage.Text = dr["HomePage"].ToString();
				txtDescription.Text = dr["Description"].ToString();

                chkArtsScience.Checked = bool.Parse(dr["ArtsAndScienceCollege"].ToString());
                chkLaw.Checked = bool.Parse(dr["LawCollege"].ToString());
                chkDistanceEducation.Checked = bool.Parse(dr["DistanceEducationCenter"].ToString());
                chkUniversityCenter.Checked = bool.Parse(dr["UniversityCollege"].ToString());
                chkPolytechnic.Checked = bool.Parse(dr["Polytechnic"].ToString());
                chkBed.Checked = bool.Parse(dr["BedCollege"].ToString());
                chkNursing.Checked = bool.Parse(dr["NursingCollege"].ToString());
                chkEngineering.Checked = bool.Parse(dr["EngineeringCollege"].ToString());
                chkMedical.Checked = bool.Parse(dr["MedicalCollege"].ToString());
					
				ddlUniversities.Items.FindByValue( dr["UniversityId"].ToString() ).Selected = true;
			}				
		}

		private void LoadUniversities()
		{
			string query = "Select Id, UniversityName from Universities order by Universityname ASC";
			DataTable table = Utils.DataManager.ExecuteQuery(query);

			ddlUniversities.DataTextField = "UniversityName";
			ddlUniversities.DataValueField = "Id";
			ddlUniversities.DataSource = table;            
			ddlUniversities.DataBind();
		}

		protected void btnCancel_Click(object sender, System.EventArgs e)
		{
			Response.Redirect("Index.aspx");
		}
	}
}
