using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;


namespace IndiaStudyChannel.Colleges
{
	/// <summary>
	/// Summary description for CollegeList.
	/// </summary>
	public partial class ViewPhoto : System.Web.UI.Page
	{
		protected string collegeName, previousLink, nextLink, title, photoPath = "";

		protected void Page_Load(object sender, System.EventArgs e)
		{
			int photoId = int.Parse(Request.QueryString["PhotoId"].ToString());

			lnkDeletePhoto.Visible = Utils.Utils.IsAdministrator();
			lnkEditPhoto.Visible = Utils.Utils.IsAdministrator();

			if ( Page.IsPostBack )
			{
				return;
			}

			LoadPhoto(photoId);
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    

		}
		#endregion

		private void LoadPhoto(int photoId)
		{
			// Get all photos of the same college so that we can display the previous/next links.
			string query = "select CollegePhotos.*, Colleges.CollegeName from CollegePhotos, Colleges where CollegeId = Colleges.Id AND CollegeId = (select CollegeId from CollegePhotos where Id = " + photoId + ") order by CollegePhotos.Id ASC";
			DataTable table = Utils.DataManager.ExecuteQuery(query);

			if (table.Rows.Count == 0 )
				return;

			int index = 0;

			// Loop through all the photos and find the one matching the current photo id.
			for (index = 0; index < table.Rows.Count ; index++ )
			{
				if ( table.Rows[index]["ID"].ToString() == photoId.ToString() )
				{
					collegeName = "<a href='CollegeDetails.aspx?CollegeId=" + table.Rows[index]["CollegeId"].ToString() + "&tab=photos'>" + table.Rows[index]["CollegeName"].ToString() + "</a>";
					title = table.Rows[index]["Title"].ToString();
					photoPath = "<IMG SRC='../pictures/colleges/" + table.Rows[index]["PhotoPath"].ToString() + "'>";
					break;
				}
			}

			if ( index == 0 )
			{
				// Display the "Previous" link
				if ( table.Rows.Count > 1 )
					nextLink = "<a href='ViewPhoto.aspx?PhotoId=" + table.Rows[1]["Id"].ToString() + "'>Next</a>";
			}
			else 
			{
				previousLink = "<a href='ViewPhoto.aspx?PhotoId=" + table.Rows[index - 1]["Id"].ToString() + "'>Previous</a>";

				// Display the "Next" link
				if ( table.Rows.Count > index + 1)
					nextLink = "<a href='ViewPhoto.aspx?PhotoId=" + table.Rows[index + 1]["Id"].ToString() + "'>Next</a>";
			}
		}

		private void DeletePhoto(int photoId)
		{
			string query = "select CollegeId, PhotoPath from CollegePhotos where Id = " + photoId;
			DataTable table = Utils.DataManager.ExecuteQuery(query);
            
			int collegeId = int.Parse(table.Rows[0]["CollegeId"].ToString());
			string fileName = table.Rows[0]["PhotoPath"].ToString();

			string savePath = Server.MapPath("../pictures/colleges/");
			string thumbsPath = savePath + "/thumbs/";

			string saveFileFullName = System.IO.Path.Combine(savePath, fileName);
			string thumbFileFullName = System.IO.Path.Combine(thumbsPath, fileName);

			if ( System.IO.File.Exists(thumbFileFullName) )
				System.IO.File.Delete(thumbFileFullName);

			if ( System.IO.File.Exists(saveFileFullName) )
				System.IO.File.Delete(saveFileFullName);

			query = "delete CollegePhotos where Id = " + photoId;
			Utils.DataManager.ExecuteNonQuery(query);

			Response.Redirect ("CollegeDetails.aspx?CollegeId=" + collegeId + "&tab=photos");
		}

		protected void lnkDeletePhoto_Click(object sender, System.EventArgs e)
		{
			if ( !Utils.Utils.IsAdministrator() )
			{
				// Only administrator can delete a photo.
				return;
			}

			int photoId = int.Parse(Request.QueryString["PhotoId"].ToString());
			DeletePhoto(photoId);
		}

		protected void lnkEditPhoto_Click(object sender, System.EventArgs e)
		{
			if ( !Utils.Utils.IsAdministrator() )
			{
				// Only administrator can delete a photo.
				return;
			}

			pnlEdit.Visible = true;

			int photoId = int.Parse(Request.QueryString["PhotoId"].ToString());

			string query = "Select * from CollegePhotos where Id = " + photoId;
			DataTable data = Utils.DataManager.ExecuteQuery(query);
			DataRow row = data.Rows[0];

			txtTitle.Text = row["Title"].ToString();
		}

		protected void btnSave_Click(object sender, System.EventArgs e)
		{
			int photoId = int.Parse(Request.QueryString["PhotoId"].ToString());
			string query = "Update CollegePhotos set Title = '" + txtTitle.Text.Replace("'", "''") + "' where Id = " + photoId;

			Utils.DataManager.ExecuteNonQuery(query);

			pnlEdit.Visible = false;

			LoadPhoto(photoId);
		}
	}
}
