using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;


namespace IndiaStudyChannel.Colleges
{
	/// <summary>
	/// Summary description for CollegeList.
	/// </summary>
	public partial class collges_index : System.Web.UI.Page
	{
	
		protected void Page_Load(object sender, System.EventArgs e)
		{
            this.Master.Page.Title = "Engineering Colleges, Medical colleges and Nursing colleges in India";

            this.Page.Form.DefaultFocus = txtSearch.ClientID;

			if ( ! Page.IsPostBack )
				LoadColleges();
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    

		}
		#endregion

		private void btnAdd_Click(object sender, System.EventArgs e)
		{
			Response.Redirect("AddCollege.aspx");
		}

		protected void btnSearch_Click(object sender, System.EventArgs e)
		{
			dgResults.CurrentPageIndex = 0;

			LoadColleges();
		}

		/// <summary>
		/// This method loads the list of colleges in the grid based on the filter criteria selected by user.
		/// If no filter criteria is selected, then all colleges will be loaded.
		/// </summary>
		private void LoadColleges()
		{
			// Query to find the colleges based on the filter criteria
            string query = "Select TOP 500 Colleges.Id, CollegeName, ('' + cast(Colleges.Id as varchar(10)) + '-' + Collegename) as URL, Colleges.City, Colleges.State, Colleges.PhoneNumber1, Colleges.HomePage, UniversityId, Universities.UniversityName from ";
			query += " Colleges, Universities WHERE Colleges.UniversityId = Universities.Id";
			query += " AND CollegeName like '" + Utils.Utils.MakeSafeWord(txtSearch.Text) + "%'";
            query += " order by Colleges.PostedDate desc";

			try
			{
				DataTable data = Utils.DataManager.ExecuteQuery(query);
				dgResults.DataSource = data;
				dgResults.DataBind();

				lblMessage.Text = data.Rows.Count.ToString() + " colleges found.";
				lblMessage.ForeColor = System.Drawing.Color.DarkGreen;
			}
			catch (Exception ex)
			{
				lblMessage.Text = ex.ToString();
				return;
			}			
		}

		/// <summary>
		/// This method is called when the page index is changed in the datagrid.
		/// </summary>
		/// <param name="o"></param>
		/// <param name="e"></param>
		protected void dgResults_PageChanger(object o, DataGridPageChangedEventArgs e)
		{
			dgResults.CurrentPageIndex = e.NewPageIndex;

			LoadColleges();
		}

        protected void dgResults_RowBind(object o, DataGridItemEventArgs e)
        {
            if (e.Item.ItemIndex >= 0)
            {
                string collegeName = e.Item.Cells[0].Text;
                string id = e.Item.Cells[1].Text;
                e.Item.Cells[0].Text = "<a href='" + CollegeServices.FormatCollegeName(int.Parse(id), collegeName) + "' Title='" + collegeName + "'>" + collegeName + "</a>";
            }
        }
	}
}
