using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace IndiaStudyChannel.Universities
{
	/// <summary>
	/// Summary description for UniversityList.
	/// </summary>
	public partial class universities_index : System.Web.UI.Page
	{
	
		protected void Page_Load(object sender, System.EventArgs e)
		{
            this.Page.Form.DefaultFocus = txtSearch.ClientID;
            this.Master.Page.Title = "Universities in India";

			if ( !Page.IsPostBack )
				LoadUniversities();
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    

		}
		#endregion

		private void btnAdd_Click(object sender, System.EventArgs e)
		{
			Response.Redirect("AddUniversity.aspx");
		}

		protected void btnSearch_Click(object sender, System.EventArgs e)
		{
			dgResults.CurrentPageIndex = 0;

			LoadUniversities();
		}

		/// <summary>
		/// This method loads the list of universities in the grid based on the filter criteria selected by user.
		/// If no filter criteria is selected, then all universities will be loaded.
		/// </summary>
		private void LoadUniversities()
		{
			// Query to find the universities based on the filter criteria. Limit the maximum number retrieved to 1000 so that 
			// our application will not slow down when we have several thousand records.
			string query = "Select TOP 1000 Universities.Id, UniversityName, City, State, PhoneNumber1, HomePage from ";
			query += " Universities WHERE UniversityName like '" + Utils.Utils.MakeSafeWord(txtSearch.Text) + "%' order by UniversityName ASC" ;

			try
			{
				DataTable data = Utils.DataManager.ExecuteQuery(query);
				dgResults.DataSource = data;
				dgResults.DataBind();

                lblMessage.Text = data.Rows.Count.ToString() + " universities found.";
                lblMessage.ForeColor = System.Drawing.Color.DarkGreen;
			}
			catch (Exception ex)
			{
				lblMessage.Text = ex.ToString();
				return;
			}
		}

		/// <summary>
		/// This method is called when the page index is changed in the datagrid.
		/// </summary>
		/// <param name="o"></param>
		/// <param name="e"></param>
		protected void dgResults_PageChanger(object o, DataGridPageChangedEventArgs e)
		{
			dgResults.CurrentPageIndex = e.NewPageIndex;

			LoadUniversities();
		}

        protected void dgResults_RowBind(object o, DataGridItemEventArgs e)
        {
            if (e.Item.ItemIndex >= 0 && e.Item.Cells.Count > 0)
            {
                string universityName = e.Item.Cells[0].Text;
                string id = e.Item.Cells[1].Text;
                e.Item.Cells[0].Text = "<a href='" + UniversityServices.FormatUniversityName(int.Parse(id), universityName) + "' Title='" + universityName + "'>" + universityName + "</a>";
            }
        }
	}
}